#include "../../../lib/std.mi"

Function OpenClosePlCtrls();
Function OpenCloseTh();
Function OpenCloseEq();
Function GetEqIds();
Function GetThIds();
Function SetEqAlphaB(int Alpha);
Function SetEqAlpha(int Alpha);
Function SetThAlphaB(int Alpha);
Function SetThAlpha(int Alpha);


Global Layout	MainObject;
Global Group	PlCtrl;
Global Group	PlEq;
Global Layer	PlEq2;
Global Group	PlEqC;
Global Group	PlTh;
Global Group	PlTh2;
Global Group	PlThC;
Global Button	AffichePlCtrls;
Global Button	AfficheEq;
Global Button	AfficheTh;
Global Int		PlCtrlOpen;
Global Int		PlCtrlWantsToBeClosed;
Global Int		PlEqOpen;
Global Int		PlEqWantsToBeClosed;
Global Int		PlThOpen;
Global Int		PlThWantsToBeClosed;
Global vis 		OrgVis;
Global Int		IsReady;
Global Timer	EqShowTimer;
Global Timer	EqHideTimer;
Global Timer	ThShowTimer;
Global Timer	ThHideTimer;
Global Int		MyAlpha, MyAlpha90;


Global Layer	Preamp, Eq1, Eq2, Eq3, Eq4, Eq5, Eq6, Eq7, Eq8, Eq9, Eq10, bg_spline;
Global Slider	Spreamp, SEq1, SEq2, SEq3, SEq4, SEq5, SEq6, SEq7, SEq8, SEq9, SEq10;
Global Eqvis	spline;
Global Button	eqonoff, eqauto, eqpresets;
Global Layer	EqText;

Global Button	Lefta, Righta;
Global Text		ThText;
Global Componentbucket	Cb;
Global Layer	ThText;

System.onScriptLoaded() {
	
	PlCtrlOpen = 0;
	PlEqOpen = 0;
	PlThOpen = 0;
	PlCtrlWantsToBeClosed = 0;
	PlEqWantsToBeClosed = 0;
	PlThWantsToBeClosed = 0;
	IsReady = 1;
	MyAlpha = 0;
	MyAlpha90 = 0;

 	MainObject = getContainer("main").getLayout("normal");
 
	AffichePlCtrls = MainObject.getObject("pl.ctrls");
	PlCtrl = MainObject.getObject("player.control");
	AfficheEq = PlCtrl.getObject("pl.eq");
	PlEq = MainObject.getObject("Player.Eq");
	PlEq2 = PlEq.getObject("bg2");
	PlEqC = PlEq.getObject("Eq.Content");
	AfficheTh = PlCtrl.getObject("pl.th");
	PlTh = MainObject.getObject("Player.Th");
	PlTh2 = PlTh.getObject("bg2");
	PlThC = PlTh.getObject("Th.Content");
	OrgVis = MainObject.getObject("visual");

	GetEqIds();
	GetThIds();

	EqShowTimer = new Timer;
	EqShowTimer.setDelay(5);
	EqHideTimer = new Timer;
	EqHideTimer.setDelay(5);
	ThShowTimer = new Timer;
	ThShowTimer.setDelay(5);
	ThHideTimer = new Timer;
	ThHideTimer.setDelay(5);
	
	PlCtrl.hide();
	PlEq.hide();
	PlEq2.hide();
	PlTh.hide();
	PlTh2.hide();
}	

//**********************************************************
//**************    Affiche Player Controls    *************
//**********************************************************


OpenClosePlCtrls() {
	if (PlCtrlOpen) {
		if (PlEqOpen ) {
			PlCtrlWantsToBeClosed = 1;
			EqHideTimer.start();
		}
		else {
			if (PlThOpen ) {
				PlCtrlWantsToBeClosed = 1;
				ThHideTimer.start();
			}
			else {
				PlCtrl.setTargetX(0);
				PlCtrl.setTargetY(0);
				PlCtrl.setTargetSpeed(1);
				PlCtrl.gotoTarget();
				PlCtrlOpen= 0;
				OrgVis.setXmlParam("h","23");
				OrgVis.SetFocus();
			}
		}
	} else {
		PlCtrl.show();
		PlCtrl.setTargetX(0);
		PlCtrl.setTargetY(26);
		PlCtrl.setTargetSpeed(1);
		PlCtrl.gotoTarget();
		PlCtrlOpen= 1;
	}
}

PlCtrl.OnTargetReached() {
	IsReady = 1;
	if (PlCtrlOpen) {
		OrgVis.setXmlParam("h","48");
		OrgVis.SetFocus();
	} else {
		PlCtrl.hide();
	}
}

AffichePlCtrls.onLeftClick() {
	int IsOk = 	!AffichePlCtrls.GetActivated();
	If (IsReady) {
		IsReady = 0;
		OpenClosePlCtrls();
	} else {
		AffichePlCtrls.SetActivated(IsOk);
	}
}

//**********************************************************
//**************    Affiche Equalizer    *******************
//**********************************************************

OpenCloseEq() {
	if (PlEqOpen ) {
		PlEq.setTargetX(0);
		PlEq.setTargetY(25);
		PlEq.setTargetSpeed(1);
		PlEq.gotoTarget();
		PlEq2.setTargetX(0);
		PlEq2.setTargetY(0);
		PlEq2.setTargetSpeed(1);
		PlEq2.gotoTarget();
		PlEqOpen = 0;
	} else {
		if (PlThOpen ) {
			PlEqWantsToBeClosed = 1;
			ThHideTimer.start();
		} else {
			PlEq.Show();
			PlEq.setTargetX(0);
			PlEq.setTargetY(51);
			PlEq.setTargetSpeed(1);
			PlEq.gotoTarget();
			PlEq2.Show();
			PlEq2.setTargetX(0);
			PlEq2.setTargetY(26);
			PlEq2.setTargetSpeed(1);
			PlEq2.gotoTarget();
			PlEqOpen = 1;
		}
	}
}

PlEq.OnTargetReached() {
	if (PlEqOpen == 0 ) {
		IsReady = 1;
		PlEq.hide();
		PlEq2.hide();
		AfficheEq.SetActivated(0);

		if (PlCtrlWantsToBeClosed) {
			PlCtrlWantsToBeClosed = 0;
			AfficheEq.SetActivated(0);
			OpenClosePlCtrls();
		}
		if (PlThWantsToBeClosed) {
			PlThWantsToBeClosed = 0;
			AfficheEq.SetActivated(0);
			OpenCloseTh();
		}
	} else {
		AfficheEq.SetActivated(1);
		EqShowTimer.start();
	}
}

AfficheEq.onLeftClick() {
	If (IsReady) {
		IsReady = 0;
			if (PlEqOpen ) {
				EqHideTimer.start();
			} else{
				OpenCloseEq();
			}
	} else {
		if (PlEqOpen) {
			AfficheEq.SetActivated(1);
		} else {
			AfficheEq.SetActivated(0);
		}
	}
}

//**********************************************************
//**************    Affiche Thinger    *********************
//**********************************************************

OpenCloseTh() {
	if (PlThOpen ) {
		PlTh.setTargetX(0);
		PlTh.setTargetY(25);
		PlTh.setTargetSpeed(1);
		PlTh.gotoTarget();
		PlTh2.setTargetX(0);
		PlTh2.setTargetY(0);
		PlTh2.setTargetSpeed(1);
		PlTh2.gotoTarget();
		PlThOpen = 0;
	} else {
		if (PlEqOpen ) {
			PlThWantsToBeClosed = 1;
			EqHideTimer.start();
		} else {
			PlTh.Show();
			PlTh.setTargetX(0);
			PlTh.setTargetY(51);
			PlTh.setTargetSpeed(1);
			PlTh.gotoTarget();
			PlTh2.Show();
			PlTh2.setTargetX(0);
			PlTh2.setTargetY(26);
			PlTh2.setTargetSpeed(1);
			PlTh2.gotoTarget();
			PlThOpen = 1;
		}
	}
}

PlTh.OnTargetReached() {
	IsReady = 1;
	if (PlThOpen == 0 ) {
		PlTh.hide();
		PlTh2.hide();
		AfficheTh.SetActivated(0);

		if (PlCtrlWantsToBeClosed) {
			PlCtrlWantsToBeClosed = 0;
			AfficheTh.SetActivated(0);
			OpenClosePlCtrls();
		}
		if (PlEqWantsToBeClosed) {
			PlEqWantsToBeClosed = 0;
			AfficheTh.SetActivated(0);
			OpenCloseEq();
		}
	} else {
		AfficheTh.SetActivated(1);
		ThShowTimer.start();
	}
}

AfficheTh.onLeftClick() {
	If (IsReady) {
		IsReady = 0;
		if (PlThOpen ) {
			ThHideTimer.start();
		} else{
			OpenCloseTh();
		}
	} else {
		if (PlThOpen) {
			AfficheTh.SetActivated(1);
		} else {
			AfficheTh.SetActivated(0);
		}
	}
}

//**********************************************************
//**************    Affiche Eq Content   *******************
//**********************************************************

GetEqIds() {
	Preamp = PlEqC.getObject("br_preamp");
	Eq1 = PlEqC.getObject("br_eq1");
	Eq2 = PlEqC.getObject("br_eq2");
	Eq3 = PlEqC.getObject("br_eq3");
	Eq4 = PlEqC.getObject("br_eq4");
	Eq5 = PlEqC.getObject("br_eq5");
	Eq6 = PlEqC.getObject("br_eq6");
	Eq7 = PlEqC.getObject("br_eq7");
	Eq8 = PlEqC.getObject("br_eq8");
	Eq9 = PlEqC.getObject("br_eq9");
	Eq10 = PlEqC.getObject("br_eq10");
	bg_spline = PlEqC.getObject("bg_spline");
	Spreamp = PlEqC.getObject("preamp");
	SEq1 = PlEqC.getObject("eq1");
	SEq2 = PlEqC.getObject("eq2");
	SEq3 = PlEqC.getObject("eq3");
	SEq4 = PlEqC.getObject("eq4");
	SEq5 = PlEqC.getObject("eq5");
	SEq6 = PlEqC.getObject("eq6");
	SEq7 = PlEqC.getObject("eq7");
	SEq8 = PlEqC.getObject("eq8");
	SEq9 = PlEqC.getObject("eq9");
	SEq10 = PlEqC.getObject("eq10");
	spline = PlEqC.getObject("spline");
	eqonoff = PlEqC.getObject("eqonoff");
	eqauto = PlEqC.getObject("eqauto");
	eqpresets = PlEqC.getObject("eqpresets");
	EqText = PlEq.getObject("TheText1");
}

SetEqAlphaB(int Alpha) {
	Preamp.SetAlpha(Alpha);
	Eq1.SetAlpha(Alpha);
	Eq2.SetAlpha(Alpha);
	Eq3.SetAlpha(Alpha);
	Eq4.SetAlpha(Alpha);
	Eq5.SetAlpha(Alpha);
	Eq6.SetAlpha(Alpha);
	Eq7.SetAlpha(Alpha);
	Eq8.SetAlpha(Alpha);
	Eq9.SetAlpha(Alpha);
	Eq10.SetAlpha(Alpha);
	bg_spline.SetAlpha(Alpha);
	spline.SetAlpha(Alpha);
	EqText.SetAlpha(Alpha);
}

SetEqAlpha(int Alpha) {
	Spreamp.SetAlpha(Alpha);
	SEq1.SetAlpha(Alpha);
	SEq2.SetAlpha(Alpha);
	SEq3.SetAlpha(Alpha);
	SEq4.SetAlpha(Alpha);
	SEq5.SetAlpha(Alpha);
	SEq6.SetAlpha(Alpha);
	SEq7.SetAlpha(Alpha);
	SEq8.SetAlpha(Alpha);
	SEq9.SetAlpha(Alpha);
	SEq10.SetAlpha(Alpha);
	eqonoff.SetAlpha(Alpha);
	eqauto.SetAlpha(Alpha);
	eqpresets.SetAlpha(Alpha);
}

EqShowTimer.onTimer() {
	EqHideTimer.Stop();
	MyAlpha = MyAlpha + 6;
	MyAlpha90 = MyAlpha90 + 2;
	if (MyAlpha90 > 90) {
		MyAlpha90 = 90;
		EqShowTimer.Stop();
		IsReady = 1;
	}
	if (MyAlpha > 255) {
		MyAlpha = 255;
	}
	SetEqAlphaB(MyAlpha90);
	SetEqAlpha(MyAlpha);
}

EqHideTimer.onTimer() {
	EqShowTimer.Stop();
	MyAlpha = MyAlpha - 6;
	MyAlpha90 = MyAlpha90 - 2;
	if (MyAlpha90 < 0) {
		MyAlpha90 = 0;
		EqHideTimer.Stop();
		OpenCloseEq();
	}
	if (MyAlpha < 0) {
		MyAlpha = 0;
	}
	SetEqAlphaB(MyAlpha90);		
	SetEqAlpha(MyAlpha);		
}

//**********************************************************
//**************    Affiche Th Content   *******************
//**********************************************************

GetThIds() {
	Lefta = PlThC.getObject("tleft");
	Righta = PlThC.getObject("tright");
	ThText = PlThC.getObject("cbtxt");
	Cb = PlThC.getObject("CB");
	ThText = PlTh2.getObject("TheText2");
}

SetThAlphaB(int Alpha) {
	Cb.SetAlpha(Alpha);
	ThText.SetAlpha(Alpha);
}

SetThAlpha(int Alpha) {
	Lefta.SetAlpha(Alpha);
	Righta.SetAlpha(Alpha);
}

ThShowTimer.onTimer() {
	ThHideTimer.Stop();
	MyAlpha = MyAlpha + 6;
	MyAlpha90 = MyAlpha90 + 2;
	if (MyAlpha90 > 90) {
		MyAlpha90 = 90;
		ThShowTimer.Stop();
		IsReady = 1;
	}
	if (MyAlpha > 255) {
		MyAlpha = 255;
	}
	SetThAlphaB(MyAlpha90);
	SetThAlpha(MyAlpha);
}

ThHideTimer.onTimer() {
	ThShowTimer.Stop();
	MyAlpha = MyAlpha - 6;
	MyAlpha90 = MyAlpha90 - 2;
	if (MyAlpha90 < 0) {
		MyAlpha90 = 0;
		ThHideTimer.Stop();
		OpenCloseTh();
	}
	if (MyAlpha < 0) {
		MyAlpha = 0;
	}
	SetThAlphaB(MyAlpha90);		
	SetThAlpha(MyAlpha);		
}



